#Zainstaluj pakiet forecast
install.packages("forecast")

#Uruchom pakier forecast
library(forecast)

#Zaimportuj dane z Excel, np. File -> Import Dataset -> From Excel...

#-----------------------------------------#
# Metoda średniej ruchomej
#Otwórz (jeśli potrzebujesz) pomoc dotycząca działania średniej ruchomej
help(ma)
#Wygenerowanie wygładzonego szeregu dla k=2
MA_Pop<-ma(Population_Poland$Population,order=2,centre=FALSE)
print(MA_Pop)
#Prognoza na podstawie wygładzonego szeregu
F1<-forecast(MA_Pop,h=5)
#Wyświetlenie prognoz puntkowych wraz z przedziałami ufności
F1
#Ocena błędów ex-post
#ME - średni błąd prognozy
#RMSE - pierwiastek błędu średniokwadratowego
#MAE - średni błąd bezwzględny
#MPE - średni procentowy błąd
#MAPE - średni bezwzględny procentowy błąd
#MASE - średni bezwwzględny błąd skalowany
#ACF1 - funkcja autokorelacji rzędu pierwszego
accuracy(F1)
#Wizualizacja szeregu i prognozy
plot(F1)

#-----------------------------------------#
# Metoda wygładzenia wykładniczego (Metoda Browna)
#Otwórz (jeśli potrzebujesz) pomoc dotycząca działania metody wygładzenia wykładniczego
help(ses)
#Wygenerowanie modelu wygładzenia wykładniczego. W praktyce ALPHA jest zwykle ustawiana na wartość pomiędzy 0,1 a 0,3
SES_Pop<-ses(Population_Poland$Population,alpha=0.5)
SES_Pop$model
#Prognoza na podstawie wygładzonego wykładniczego
F2<-forecast(SES_Pop,h=5)
#Wyświetlenie prognoz puntkowych wraz z przedziałami ufności
F2
#Ocena błędów ex-post
accuracy(F2)
#Wizualizacja szeregu i prognozy
plot(F2)

#-----------------------------------------#
# Metoda Holta
#Otwórz (jeśli potrzebujesz) pomoc dotycząca działania metody Holta 
help(ses)
#przekształcenie danych na szereg czasowy
Pop<-ts(Population_Poland$Population,frequency = 1,start = c(1,1))
Pop
#Uwaga! pojawi się błąd dla danych rocznych!! brak możliwości dekompozycji
HW<-HoltWinters(Pop)
#Wizualizacja szeregu
plot(HW)
#Prognoza na podstawie metody Holta
F3<-forecast(HW,h=5)
#Wyświetlenie prognoz puntkowych wraz z przedziałami ufności
F3
#Ocena błędów ex-post
accuracy(F3)
#Wizualizacja szeregu i prognozy
plot(F3)
